## libjna-java 4.2.2

=== native/Makefile ===
#
# Makefile for JNA native bits
# Copyright (c) 2007-2014 Timothy Wall All Rights Reserved
#
# You may need to run 'ant javah' at the root before performing a build from
# this directory.
#
# To build with debug information, use 'make DEBUG=true'
#
# Supported platforms (built and tested):
#
#   Windows 2000/XP/2003/Vista (x86/amd64)
#   Windows CE/Mobile (arm)
#   Darwin/OS X (i386/x86_64/ppc)
#   Linux (i386/amd64/ppc/arm)
#   Solaris (i386/amd64/sparc/sparcv9)
#   AIX (ppc/ppc64)
#   FreeBSD/OpenBSD/NetBSD (i386/amd64)
#   Android (arm/armv7/aarch64/x86/x86-64/mipsel/mips64el)
#
# Built, but with outstanding bugs (not necessarily within JNA):
#
#   Linux (ppc64/ppc64le/ia64)
#
# The w32ce build requires cegcc and phoneME for cross-compilation; if these
# tools are available on the path then "ant -Dos.prefix=w32ce-arm" should
# result in a proper build.
#
# The android build requires the android SDK+NDK for cross-compilation;
# make the tools available on the path and compile with
# "ant -Dos.prefix=android-{arm|x86}".  Put the NDK tools in the path and adjust
# NDK_PLATFORM below or set it in your environment.
#
# The windows build requires a cygwin installation.  The build will use MSVC
# for compilation if cl.exe is found on the PATH, otherwise the build will fall 
# back to mingw.

# Systems which support POSIX signals may be able to support VM crash
# protection simply by defining HAVE_PROTECTION.  This option has been only
# been enabled for those platforms on which it has been tested successfully.

OS=$(shell uname | sed -e 's/CYGWIN.*/win32/g' \
	                -e 's/MINGW32.*/win32/g' \
                        -e 's/SunOS.*/solaris/g' \
                        -e 's/NetBSD/netbsd/g' \
                        -e 's/GNU\/kFreeBSD/kfreebsd/g' \
                        -e 's/FreeBSD/freebsd/g' \
                        -e 's/OpenBSD/openbsd/g' \
                        -e 's/Darwin.*/darwin/g' \
                        -e 's/AIX.*/aix/g' \
                        -e 's/Linux.*/linux/g')

JNA_JNI_VERSION=4.0.1 # auto-generated by ant
CHECKSUM=1a6047467b59e8748f975e03016ce3d9 # auto-generated by ant

JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
              -I"$(JAVA_HOME)/include/$(OS)"

BUILD=../build/native
JAVAH=$(BUILD)
INSTALLDIR=../build/$(OS)
JNIDISPATCH_OBJS=$(BUILD)/dispatch.o $(BUILD)/callback.o $(EXTRAOBJS)
RSRC=$(BUILD)/rsrc.o
DLLCB=$(BUILD)/dll-callback.o
ifneq ($(DYNAMIC_LIBFFI),true)
FFI_SRC=$(shell pwd)/libffi
FFI_BUILD=$(BUILD)/libffi
FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
FFI_ENV=CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)"
FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
endif
LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
TESTLIB=$(BUILD)/$(LIBPFX)testlib$(LIBSFX)
TESTLIB_JAR=$(BUILD)/$(LIBPFX)testlib-jar$(LIBSFX)
TESTLIB_PATH=$(BUILD)/$(LIBPFX)testlib-path$(LIBSFX)
TESTLIB_TRUNC=$(BUILD)/testlib-truncated
TESTLIB2=$(BUILD)/$(LIBPFX)testlib2$(LIBSFX)

# Reasonable defaults based on GCC
LIBPFX=lib
LIBSFX=.so
ARSFX=.a
JNISFX=$(LIBSFX)
CC=gcc
LD=$(CC)
LIBS=
# Default to Sun recommendations for JNI compilation
COPT=-O2 -fno-omit-frame-pointer -fno-strict-aliasing
CASM=-S
ifeq ($(DEBUG),true)
CDEBUG=-g
endif
CFLAGS_EXTRA=
COUT=-o $@
CINCLUDES=$(JAVA_INCLUDES) -I"$(JAVAH)" -I$(FFI_BUILD)/include
CDEFINES=-D_REENTRANT
PCFLAGS=-W -Wall -Wno-unused -Wno-parentheses
CFLAGS=$(PCFLAGS) $(CFLAGS_EXTRA) $(COPT) $(CDEBUG) $(CDEFINES) $(CINCLUDES) \
       -DJNA_JNI_VERSION='"$(JNA_JNI_VERSION)"' -DCHECKSUM='"$(CHECKSUM)"'
LDFLAGS=-o $@ -shared
ifeq ($(DYNAMIC_LIBFFI),true)
CFLAGS += $(shell pkg-config --cflags libffi 2>/dev/null || echo)
LIBS += $(shell pkg-config --libs libffi 2>/dev/null || echo -lffi)
else
# -static-libgcc avoids gcc library incompatibilities across linux systems
LDFLAGS += -static-libgcc
endif
# Avoid bug in X11-based 1.5/1.6 VMs; dynamically load instead of linking
# See http://bugs.sun.com/bugdatabase/view_bug.do?bug_id=6539705
#LIBS=-L"$(LIBDIR)" -ljawt
STRIP=strip -x
# end defaults

# Android build (cross-compile) requires the android NDK.
# Ensure the following tools are in your path and adjust NDK_PLATFORM as needed
ifeq ($(OS),android)
AARCH=$(ARCH)
ALIBDIR=/usr/lib
ifeq ($(ARCH),arm)
PREFIX=arm-linux-androideabi-
COPT+= -mthumb-interwork -march=armv5te -mtune=xscale -msoft-float -fstack-protector 
HOST=arm-linux-eabi
else ifeq ($(ARCH),armv7)
PREFIX=arm-linux-androideabi-
COPT+= -march=armv7-a -mfloat-abi=softfp -mfpu=vfpv3-d16 -Wl,--fix-cortex-a8
HOST=arm-linux-eabi
AARCH=arm
else ifeq ($(ARCH),aarch64)
PREFIX=aarch64-linux-android-
HOST=aarch64-linux-android
AARCH=arm64
ALIBDIR=/usr/lib64
else ifeq ($(ARCH),x86)
PREFIX=i686-linux-android-
COPT+= -march=i686
HOST=i686-linux-android
else ifeq ($(ARCH),x86-64)
PREFIX=x86_64-linux-android-
COPT+= -m64
HOST=x86_64-linux-android
AARCH=x86_64
ALIBDIR=/usr/lib64
else ifeq ($(ARCH),mips)
PREFIX=mipsel-linux-android-
HOST=mipsel-linux-android
COPT+=
else ifeq ($(ARCH),mips64)
PREFIX=mips64el-linux-android-
HOST=mips64el-linux-android
COPT+=
ALIBDIR=/usr/lib64
else
ERROR = $(error "Unsupported android architecture '$(ARCH)'")
endif
NDK?=/Developer/Applications/android-ndk-r10e
NDK_PLATFORM?=$(NDK)/platforms/android-21
SYSROOT=$(NDK_PLATFORM)/arch-$(AARCH)
CC=$(PREFIX)gcc --sysroot $(SYSROOT)
CPP=$(PREFIX)cpp
LD=$(CC)
RANLIB=$(PREFIX)ranlib
STRIP=$(PREFIX)strip -x
CDEFINES=-DNO_JAWT -DNO_WEAK_GLOBALS -DFFI_MMAP_EXEC_WRIT=1 -DFFI_MMAP_EXEC_SELINUX=0
COPT+=-fpic -ffunction-sections -funwind-tables -fno-short-enums
JAVA_INCLUDES=
CINCLUDES+=-I"$(NDK_PLATFORM)/arch-$(AARCH)/usr/include" # -I/usr/include
LIBS=-nostdlib -L"$(NDK_PLATFORM)/arch-$(AARCH)$(ALIBDIR)/" -lgcc -lc -ldl -lm
LDFLAGS+=-Wl,-shared,-Bsymbolic
FFI_ENV=CPP="$(CPP)" CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG) $(CINCLUDES)" CPPFLAGS="$(CDEFINES) $(CINCLUDES)" LIBS="$(LIBS)" RANLIB="$(RANLIB)"
FFI_CONFIG=--enable-static --disable-shared --with-pic=yes --host=$(HOST)
endif

# W32CE build requires cegcc cross-compiler and phoneME JavaME implementation
# cegcc: http://sf.net/projects/cegcc
# phoneme: http://davy.preuveneers.net/
ifeq ($(OS),w32ce)
ARCH=arm
CC=arm-mingw32ce-gcc -mwin32
CDEFINES=-D_WIN32_IE=0x400 -D_WIN32_WCE=0x0420 -DNO_JAWT -DNO_NIO_BUFFERS -DWINCE -D_WIN32_STDARG_H
CFLAGS+=-Wno-unknown-pragmas
LD=arm-mingw32ce-gcc
LDFLAGS=-o $@ -shared
LIBS=-lcoredll -lgcc -ltoolhelp
WINDRES=arm-mingw32ce-windres
EXTRAOBJS=$(RSRC)
STRIP=arm-mingw32ce-strip -x
LIBPFX=
LIBSFX=.dll
HOST_CONFIG=--host=arm-mingw32ce
# libffi must use GNU ld; jnidispatch.dll requires gcc
FFI_ENV+=LD=arm-mingw32ce-ld CPP=cpp CFLAGS="$(CDEFINES)"
PHONEME=../phoneme/cdc/src
JAVA_INCLUDES=-I$(PHONEME)/share/javavm/export -I$(PHONEME)/share -I$(PHONEME)/win32 -I$(PHONEME)/win32-arm
TESTLIB_TRUNC=$(BUILD)/testlib-truncated.dll
endif

ifeq ($(OS),win32)
ifeq ($(shell type cl >& /dev/null && echo found),found)
USE_MSVC=true
endif
# This will be overridden when called from ant
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
CDEFINES=-DHAVE_PROTECTION -DPSAPI_VERSION=1 -DFFI_BUILDING -DUNICODE -D_UNICODE
WINDRES=windres
EXTRAOBJS=$(RSRC)
STRIP=@echo
LIBPFX=
LIBSFX=.dll
TESTLIB_TRUNC=$(BUILD)/testlib-truncated.dll
ifeq ($(ARCH),amd64)
MINGW_PREFIX?=x86_64-w64-mingw32-
FFI_CONFIG+=--host=x86_64-w64-mingw32
# Need windres from mingw distribution, even if building with MSVC
WINDRES=$(MINGW_PREFIX)windres
MINGW=$(MINGW_PREFIX)gcc 
else
MINGW_PREFIX?=i686-pc-mingw32-
endif

ifeq ($(USE_MSVC),true)
# MS compiler
CC=$(FFI_SRC)/msvcc.sh
COPT=
CPP=cl -nologo -EP
LD=link
LDFLAGS=/DLL /OUT:$@
LIBS=psapi.lib
ARSFX=.lib
ifeq ($(ARCH),amd64)
CC+= -m64
endif
FFI_CONFIG+= && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
FFI_ENV+=LD="$(LD)" CPP="$(CPP)" CXXCPP="$(CPP)"
EXTRAOBJS+=$(DLLCB)

else
# Mingw compiler
LDFLAGS=-o $@ -shared
FFI_ENV+=CXXCPP="$(CPP)"

ifneq ($(ARCH),amd64)
CC=$(MINGW_PREFIX)gcc
CPP=$(MINGW_PREFIX)gcc -E
LDFLAGS+=-Wl,--add-stdcall-alias
LIBS=-lpsapi
else
# mingw64 lacks SEH, so MSVC build is preferred
CC=$(MINGW)
# No SEH under mingw64, thus no HAVE_PROTECTION
CDEFINES=-DPSAPI_VERSION=1
LD = $(CC)
LIBS= -lmingwex -lpsapi -lkernel32 -lmsvcrt
endif
endif

endif

ifeq ($(OS),linux)
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION
ifeq ($(DYNAMIC_LIBFFI),true)
LDFLAGS+=-Wl,-soname,$@
else
# Ensure we bind to local libffi symbols
LDFLAGS+=-Wl,-soname,$@,-Bsymbolic
endif
endif

ifneq (,$(findstring bsd,$(OS)))
ARCH=$(shell uname -m | sed 's/i.86/i386/g')
PCFLAGS+=-fPIC
CINCLUDES+=-I/usr/X11R6/include
LDFLAGS=-o $@ -shared
CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT -DUSE_DEAFULT_LIBNAME_ENCODING
endif

ifeq ($(OS),solaris)
ifeq ($(ARCH),)
ARCH=$(shell uname -p)
endif
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT -DUSE_DEFAULT_LIBNAME_ENCODING
ifeq ($(ARCH), sparcv9)
  # alter CC instead of PCFLAGS, since we need to pass it down to libffi
  # configure and some of the other settings in PCFLAGS might make the build
  # choke
  CC += -m64
  LD += -m64
endif
endif


ifeq ($(OS),aix)
LIBSFX=.a
PCFLAGS+=-fPIC
CDEFINES+=-DHAVE_PROTECTION -DNO_JAWT -Wall -D_AIX -DPOWERPC_AIX -D_THREAD_SAFE_ERRNO
COPT+=-D_AIX -DPOWERPC_AIX -mxl-compat
LDFLAGS+=-Wl,-lc128,-lc,-lm,-lpthread
FFI_ENV+=AR_FLAGS="-X32_64 cru"
STRIP=echo strip -X32_64

ifeq ($(ARCH),ppc64)
  COPT+=-maix64
  LDFLAGS+=$(COPT)
  HOST_CONFIG=--host=ppc-aix64
endif
ifeq ($(ARCH),ppc)
  COPT+=-maix32
  LDFLAGS+=$(COPT)
  HOST_CONFIG=--host=ppc-aix
endif
endif


# Enable 64-bit builds if the arch demands it
ifeq ($(CC),gcc)
ifneq ($(OS),aix)
ifeq ($(ARCH),amd64)
  CC += -m64
  LD += -m64
endif
ifeq ($(ARCH),ppc64)
  CC += -m64
  LD += -m64
endif
ifeq ($(ARCH),ppc64le)
  CC += -m64
  LD += -m64
endif
ifeq ($(ARCH),ppc)
  CC += -m32
  LD += -m32
  HOST_CONFIG=--host=ppc-linux
endif
ifeq ($(ARCH),i386)
  CC += -m32
  LD += -m32
endif
endif
endif


ifeq ($(OS),darwin)
XCODE_VERSION=$(shell xcodebuild -version | grep Xcode | sed 's/^Xcode \([1-9]\).*/\1/g')
JAVA_INCLUDES+=-I/System/Library/Frameworks/JavaVM.framework/Headers
DEFAULT_ARCH=$(shell arch)
ARCH=$(shell arch)
HOST_CONFIG=--host $(ARCH)-apple-darwin
FFI_ENV += CC="$(CC)" CFLAGS="-arch $(ARCH) $(ISYSROOT) $(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)" LD="$(LD) -arch $(ARCH)"
ALT_ARCHS=
ifneq ($(ARCH),i386)
ALT_ARCHS+=i386
endif
ifneq ($(ARCH),x86_64)
ALT_ARCHS+=x86_64
endif
ifneq ($(ARCH),ppc)
ifeq ($(XCODE_VERSION),3)
# Xcode 3 options
# not supported on XCode 4+
ALT_ARCHS+=ppc
else
# Xcode 4+ options
NO_COMPACT_UNWIND=-Wl,-no_compact_unwind
endif
endif
LIBSFX=.dylib
JNISFX=.jnilib
ifneq ($(SDKROOT),)
SYSLIBROOT=-Wl,-syslibroot,$(SDKROOT)
ISYSROOT=-isysroot $(SDKROOT)
ARCHFLAGS=-arch i386 -arch x86_64
ifeq ($(XCODE_VERSION),3)
ARCHFLAGS+=-arch ppc
endif
endif

PCFLAGS+=$(ISYSROOT) -x objective-c
# JAWT no longer supported on OSX
CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT -DNO_JAWT
LDFLAGS=$(ARCHFLAGS) -dynamiclib -o $@ -framework JavaVM \
  -compatibility_version $(shell echo ${JNA_JNI_VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
  -current_version $(JNA_JNI_VERSION) \
  -mmacosx-version-min=10.3 \
  -framework Foundation \
  $(NO_COMPACT_UNWIND) \
  -install_name ${@F} \
  $(SYSLIBROOT)
# JAWT linkage handled by -framework JavaVM
LIBS=
endif

# Unfortunately, we have to use different libffi include files depending on
# the target, so we can't do a simple universal build on darwin.  Do
# separate builds, then merge the results.
$(BUILD)/%.o : %.c dispatch.h protect.h $(FFI_LIB)
	@mkdir -p $(BUILD)
ifneq ($(SDKROOT),)
	$(CC) -arch $(ARCH) $(CFLAGS) -c $< -o $@.$(ARCH)
	for arch in $(ALT_ARCHS); do \
	  $(CC) -arch $$arch -I$(BUILD)/libffi.$$arch/include $(CFLAGS) -c $< -o $@.$$arch; \
	done
	lipo -create -output $@ $@.*
else
	$(CC) $(CFLAGS) -c $< $(COUT)
endif

all: $(LIBRARY) $(TESTLIB) $(TESTLIB2) $(TESTLIB_JAR) $(TESTLIB_PATH) $(TESTLIB_TRUNC)

install:
	mkdir $(INSTALLDIR)
	cp $(LIBRARY) $(INSTALLDIR)

ifeq ($(ARCH), amd64)

=== debian/changelog ===
libjna-java (4.2.2-3) unstable; urgency=medium

  * Team upload.
  * Ignore the jna.boot.library.path and jna.boot.library.name properties
    and always load the system jnidispatch library (Closes: #858876)

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 12 Apr 2017 10:52:44 +0200

libjna-java (4.2.2-2) unstable; urgency=medium

  * Team upload.
  * Drop build-dependency on hardening-wrapper. (Closes: #836632)
  * Standards-Version updated to 3.9.8 (no changes)

 -- tony mancill <tmancill@debian.org>  Sun, 04 Sep 2016 21:40:00 -0700

libjna-java (4.2.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
  * Renamed the native library to avoid conflicts with other JNA jars used
    on the system (LP: #1065253)
  * Improved the reproducibility:
    - Use the year of the source date in the copyright notice of the javadoc
  * Standards-Version updated to 3.9.7 (no changes)
  * Use secure Vcs-* fields
  * Call dh_installchangelogs only once during the build

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 23 Mar 2016 13:45:27 +0100

=== debian/control ===
Source: libjna-java
Section: java
Priority: optional
Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
Uploaders: Jan Dittberner <jandd@debian.org>,
           Ludovic Claude <ludovic.claude@laposte.net>,
           Andrew Ross <ubuntu@rossfamily.co.uk>
Build-Depends: ant,
               ant-optional,
               debhelper (>= 9),
               default-jdk,
               default-jdk-doc,
               javahelper (>=0.32~),
               libffi-dev,
               libx11-dev,
               libxt-dev,
               maven-repo-helper (>= 1.5~),
               pkg-config
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-java/libjna-java.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/libjna-java.git
Homepage: https://github.com/twall/jna

Package: libjna-java
Architecture: all
Depends: libjna-jni, ${misc:Depends}
Suggests: libjna-java-doc
Description: Dynamic access of native libraries from Java without JNI
 JNA provides Java programs easy access to native shared libraries without
 writing anything but Java code - no JNI or native code is required. This
 functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
 Access is dynamic at runtime without code generation.
 .
 JNA's design aims to provide native access in a natural way with a minimum of
 effort. No boilerplate or generated code is required. While some attention is
 paid to performance, correctness and ease of use take priority.
 .
 The JNA library uses a small native library stub to dynamically invoke native
 code. The developer uses a Java interface to describe functions and structures
 in the target native library. This makes it quite easy to take advantage of
 native platform features without incurring the high overhead of configuring and
 building JNI code for multiple platforms.

Package: libjna-jni
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Dynamic access of native libraries from Java without JNI (native libs)
 JNA provides Java programs easy access to native shared libraries without
 writing anything but Java code - no JNI or native code is required. This
 functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
 Access is dynamic at runtime without code generation.
 .
 This package contains the native libraries for libjna-java

Package: libjna-platform-java
Architecture: all
Depends: libjna-java, ${misc:Depends}
Replaces: libjna-java (<< 3.4.2)
Breaks: libjna-java (<< 3.4.2)
Description: Dynamic access of native libraries from Java without JNI (platform extension)
 JNA provides Java programs easy access to native shared libraries without
 writing anything but Java code - no JNI or native code is required. This
 functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
 Access is dynamic at runtime without code generation.
 .
 This package contains the platform library with many native functions already
 mapped as well as a set of utility interfaces that simplify native access.

Package: libjna-java-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Dynamic access of native libraries from Java without JNI (documentation)
 JNA provides Java programs easy access to native shared libraries without
 writing anything but Java code - no JNI or native code is required. This
 functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
 Access is dynamic at runtime without code generation.
 .
 This package contains the Javadoc API documentation.

=== debian/rules ===
#!/usr/bin/make -f

export JAVA_HOME=/usr/lib/jvm/default-java

DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

VERSION = $(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
DATE    = $(shell dpkg-parsechangelog --show-field Date)

%:
	dh $@

override_dh_auto_clean:
	#ant -f build.xml -Dmaven-release=true clean
	find -name build -type d | xargs -r rm -Rf
	rm -f build.number
	rm -rf build doc
	rm -rf contrib/platform/build
	rm -rf contrib/platform/dist
	rm -Rf contrib/ntservice/dist
	rm -f dist/*
	mh_clean
	dh_clean

override_dh_auto_build:
	ant -f build.xml \
	    -Dcflags_extra.native="" \
	    -Ddynlink.native=true \
	    -Dnomixedjar.native=true \
	    -Djni.md5="" \
	    -Djar.compress=true \
	    -Dmaven-release=true \
	    -Dbuild-native=true \
	    -Dyear=$(shell date --date='$(DATE)' --utc +'%Y') \
	    jar javadoc contrib-jars native

# install. using platform.jar is a silly idea in /usr/share/java/ as it's bound to collide
override_dh_auto_install:
	mh_installpom -plibjna-java -e$(VERSION) pom-jna.xml
	mh_installjar -plibjna-java -e$(VERSION) --java-lib --usj-name=jna pom-jna.xml build/jna.jar

	mh_installpom -plibjna-platform-java -e$(VERSION) pom-jna-platform.xml
	mh_installjar -plibjna-platform-java -e$(VERSION) --java-lib --usj-name=jna-platform pom-jna-platform.xml contrib/platform/dist/jna-platform.jar

	dh_install -plibjna-jni build/native*/libjnidispatch.system.so usr/lib/$(DEB_HOST_MULTIARCH)/jni

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGES.md

override_dh_makeshlibs:
	# don't call dh_makeshlibs

override_dh_compress:
	dh_compress -X.java

binary: binary-arch binary-indep

## libjna-java 4.5.0

=== debian/changelog ===
libjna-java (4.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Standards-Version updated to 4.1.0

 -- Emmanuel Bourg <ebourg@apache.org>  Fri, 15 Sep 2017 14:43:54 +0200

libjna-java (4.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
    - Added a link to ant.jar in the lib directory
  * Install the javadoc under /usr/share/doc/libjna-java/api
  * Include /usr/share/dpkg/pkg-info.mk instead of parsing dpkg-parsechangelog
  * Standards-Version updated to 4.0.0
  * Switch to debhelper level 10

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 05 Jul 2017 15:31:09 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
            Andrew Ross <ubuntu@rossfamily.co.uk>
 Build-Depends: ant,
                ant-optional,
-               debhelper (>= 9),
+               debhelper (>= 10),
                default-jdk,
                default-jdk-doc,
                javahelper (>=0.32~),
@@ -16,7 +16,7 @@
                libxt-dev,
                maven-repo-helper (>= 1.5~),
                pkg-config
-Standards-Version: 3.9.8
+Standards-Version: 4.1.0
 Vcs-Git: https://anonscm.debian.org/git/pkg-java/libjna-java.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/libjna-java.git
 Homepage: https://github.com/twall/jna

## libjna-java 4.5.1

=== native/Makefile ===
--- 
+++ 
@@ -50,8 +50,8 @@
                         -e 's/AIX.*/aix/g' \
                         -e 's/Linux.*/linux/g')
 
-JNA_JNI_VERSION=4.0.1 # auto-generated by ant
-CHECKSUM=1a6047467b59e8748f975e03016ce3d9 # auto-generated by ant
+JNA_JNI_VERSION=5.1.0 # auto-generated by ant
+CHECKSUM=74e8f8e397c43487738c5c1f1363498b # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
               -I"$(JAVA_HOME)/include/$(OS)"
@@ -120,37 +120,49 @@
 PREFIX=arm-linux-androideabi-
 COPT+= -mthumb-interwork -march=armv5te -mtune=xscale -msoft-float -fstack-protector 
 HOST=arm-linux-eabi
-else ifeq ($(ARCH),armv7)
+else
+ifeq ($(ARCH),armv7)
 PREFIX=arm-linux-androideabi-
 COPT+= -march=armv7-a -mfloat-abi=softfp -mfpu=vfpv3-d16 -Wl,--fix-cortex-a8
 HOST=arm-linux-eabi
 AARCH=arm
-else ifeq ($(ARCH),aarch64)
+else
+ifeq ($(ARCH),aarch64)
 PREFIX=aarch64-linux-android-
 HOST=aarch64-linux-android
 AARCH=arm64
 ALIBDIR=/usr/lib64
-else ifeq ($(ARCH),x86)
+else
+ifeq ($(ARCH),x86)
 PREFIX=i686-linux-android-
 COPT+= -march=i686
 HOST=i686-linux-android
-else ifeq ($(ARCH),x86-64)
+else
+ifeq ($(ARCH),x86-64)
 PREFIX=x86_64-linux-android-
 COPT+= -m64
 HOST=x86_64-linux-android
 AARCH=x86_64
 ALIBDIR=/usr/lib64
-else ifeq ($(ARCH),mips)
+else
+ifeq ($(ARCH),mips)
 PREFIX=mipsel-linux-android-
 HOST=mipsel-linux-android
 COPT+=
-else ifeq ($(ARCH),mips64)
+else
+ifeq ($(ARCH),mips64)
 PREFIX=mips64el-linux-android-
 HOST=mips64el-linux-android
 COPT+=
 ALIBDIR=/usr/lib64
 else
 ERROR = $(error "Unsupported android architecture '$(ARCH)'")
+endif
+endif
+endif
+endif
+endif
+endif
 endif
 NDK?=/Developer/Applications/android-ndk-r10e
 NDK_PLATFORM?=$(NDK)/platforms/android-21
@@ -200,26 +212,32 @@
 endif
 # This will be overridden when called from ant
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
-CDEFINES=-DHAVE_PROTECTION -DPSAPI_VERSION=1 -DFFI_BUILDING -DUNICODE -D_UNICODE
+CDEFINES=-DPSAPI_VERSION=1 -DFFI_BUILDING -DUNICODE -D_UNICODE
 WINDRES=windres
 EXTRAOBJS=$(RSRC)
 STRIP=@echo
 LIBPFX=
 LIBSFX=.dll
 TESTLIB_TRUNC=$(BUILD)/testlib-truncated.dll
+
 ifeq ($(ARCH),amd64)
 MINGW_PREFIX?=x86_64-w64-mingw32-
 FFI_CONFIG+=--host=x86_64-w64-mingw32
+else
+FFI_CONFIG+=--host=i686-w64-mingw32
+MINGW_PREFIX?=i686-w64-mingw32-
+endif
 # Need windres from mingw distribution, even if building with MSVC
 WINDRES=$(MINGW_PREFIX)windres
-MINGW=$(MINGW_PREFIX)gcc 
-else
-MINGW_PREFIX?=i686-pc-mingw32-
-endif
+MINGW=$(MINGW_PREFIX)gcc
 
 ifeq ($(USE_MSVC),true)
 # MS compiler
 CC=$(FFI_SRC)/msvcc.sh
+CDEFINES+=-DHAVE_PROTECTION 
+ifneq ($(DYNAMIC_LIBFFI),true)
+CDEFINES+=-DUSE_STATIC_RTL
+endif
 COPT=
 CPP=cl -nologo -EP
 LD=link
@@ -237,20 +255,10 @@
 # Mingw compiler
 LDFLAGS=-o $@ -shared
 FFI_ENV+=CXXCPP="$(CPP)"
-
-ifneq ($(ARCH),amd64)
 CC=$(MINGW_PREFIX)gcc
 CPP=$(MINGW_PREFIX)gcc -E
 LDFLAGS+=-Wl,--add-stdcall-alias
-LIBS=-lpsapi
-else
-# mingw64 lacks SEH, so MSVC build is preferred
-CC=$(MINGW)
-# No SEH under mingw64, thus no HAVE_PROTECTION
-CDEFINES=-DPSAPI_VERSION=1
-LD = $(CC)
 LIBS= -lmingwex -lpsapi -lkernel32 -lmsvcrt
-endif
 endif
 
 endif
@@ -279,7 +287,7 @@
 ifeq ($(ARCH),)
 ARCH=$(shell uname -p)
 endif
-PCFLAGS+=-fPIC
+PCFLAGS+=-fPIC -std=gnu99
 CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT -DUSE_DEFAULT_LIBNAME_ENCODING
 ifeq ($(ARCH), sparcv9)
   # alter CC instead of PCFLAGS, since we need to pass it down to libffi
@@ -312,6 +320,27 @@
 endif
 endif
 
+# CC_OPTS only applied to objects build for jnidispatch, not for libffi
+# -Wno-unknown-warning-option 
+#                => Suppress warning for unknown warnings
+# -Werror        => Treat warnings as errors
+# -Wno-clobbered => Silence GCC warning about clobbered automatic variables.
+#                   The "longjmp" case only happens in protect.h in the logic
+#                   that implements "protected" mode. In that case an exception
+#                   is raised and the value of the potentially clobbered
+#                   variables is ignored.
+#
+# Enable this only on GCC versions, that can work with it. It is assumed, that
+# GCC version 4.X is the lower bound. That version is problematic, as it
+# does not support -Wno-unknown-warning-option
+ifeq ($(CC),gcc)
+    GCC_MAJOR_VERSION = $(shell gcc -dumpversion | cut -f 1 -d '.')
+    ifneq ($(GCC_MAJOR_VERSION),4)
+	LOC_CC_OPTS=-Wno-unknown-warning-option -Werror -Wno-clobbered -Wno-unused-variable
+    endif
+else
+    LOC_CC_OPTS=-Wno-unknown-warning-option -Werror -Wno-clobbered -Wno-unused-variable
+endif
 
 # Enable 64-bit builds if the arch demands it
 ifeq ($(CC),gcc)
@@ -379,37 +408,3 @@
 PCFLAGS+=$(ISYSROOT) -x objective-c
 # JAWT no longer supported on OSX
 CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT -DNO_JAWT
-LDFLAGS=$(ARCHFLAGS) -dynamiclib -o $@ -framework JavaVM \
-  -compatibility_version $(shell echo ${JNA_JNI_VERSION}|sed 's/^\([0-9][0-9]*\).*/\1/g') \
-  -current_version $(JNA_JNI_VERSION) \
-  -mmacosx-version-min=10.3 \
-  -framework Foundation \
-  $(NO_COMPACT_UNWIND) \
-  -install_name ${@F} \
-  $(SYSLIBROOT)
-# JAWT linkage handled by -framework JavaVM
-LIBS=
-endif
-
-# Unfortunately, we have to use different libffi include files depending on
-# the target, so we can't do a simple universal build on darwin.  Do
-# separate builds, then merge the results.
-$(BUILD)/%.o : %.c dispatch.h protect.h $(FFI_LIB)
-	@mkdir -p $(BUILD)
-ifneq ($(SDKROOT),)
-	$(CC) -arch $(ARCH) $(CFLAGS) -c $< -o $@.$(ARCH)
-	for arch in $(ALT_ARCHS); do \
-	  $(CC) -arch $$arch -I$(BUILD)/libffi.$$arch/include $(CFLAGS) -c $< -o $@.$$arch; \
-	done
-	lipo -create -output $@ $@.*
-else
-	$(CC) $(CFLAGS) -c $< $(COUT)
-endif
-
-all: $(LIBRARY) $(TESTLIB) $(TESTLIB2) $(TESTLIB_JAR) $(TESTLIB_PATH) $(TESTLIB_TRUNC)
-
-install:
-	mkdir $(INSTALLDIR)
-	cp $(LIBRARY) $(INSTALLDIR)
-
-ifeq ($(ARCH), amd64)

=== debian/changelog ===
libjna-java (4.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Removed the contradicting javadoc patches
  * Standards-Version updated to 4.1.3

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 10 Jan 2018 00:32:50 +0100

libjna-java (4.5.0-2) unstable; urgency=medium

  * Team upload.
  * Fixed the build failure with Java 9 (Closes: #874649)
  * Standards-Version updated to 4.1.1

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 29 Nov 2017 17:20:25 +0100

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
                libxt-dev,
                maven-repo-helper (>= 1.5~),
                pkg-config
-Standards-Version: 4.1.0
+Standards-Version: 4.1.3
 Vcs-Git: https://anonscm.debian.org/git/pkg-java/libjna-java.git
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/libjna-java.git
 Homepage: https://github.com/twall/jna

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export JAVA_HOME=/usr/lib/jvm/default-java

DEB_HOST_MULTIARCH = $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_clean:
	#ant -f build.xml -Dmaven-release=true clean
	find -name build -type d | xargs -r rm -Rf
	rm -f build.number
	rm -rf build doc
	rm -rf contrib/platform/build
	rm -rf contrib/platform/dist
	rm -Rf contrib/ntservice/dist
	rm -f dist/*
	rm -f lib/*.jar
	mh_clean
	dh_clean

override_dh_auto_build:
	ln -s /usr/share/java/ant.jar lib/ant.jar
	ant -f build.xml \
	    -Dcflags_extra.native="" \
	    -Ddynlink.native=true \
	    -Dnomixedjar.native=true \
	    -Djni.md5="" \
	    -Djar.compress=true \
	    -Dmaven-release=true \
	    -Dbuild-native=true \
	    -Dyear=$(shell date --date='@$(SOURCE_DATE_EPOCH)' --utc +'%Y') \
	    jar javadoc contrib-jars native

# install. using platform.jar is a silly idea in /usr/share/java/ as it's bound to collide
override_dh_auto_install:
	mh_installpom -plibjna-java -e$(DEB_VERSION_UPSTREAM) pom-jna.xml
	mh_installjar -plibjna-java -e$(DEB_VERSION_UPSTREAM) --java-lib --usj-name=jna pom-jna.xml build/jna.jar

	mh_installpom -plibjna-platform-java -e$(DEB_VERSION_UPSTREAM) pom-jna-platform.xml
	mh_installjar -plibjna-platform-java -e$(DEB_VERSION_UPSTREAM) --java-lib --usj-name=jna-platform pom-jna-platform.xml contrib/platform/dist/jna-platform.jar

	dh_install -plibjna-jni build/native*/libjnidispatch.system.so usr/lib/$(DEB_HOST_MULTIARCH)/jni

override_dh_installchangelogs:
	dh_installchangelogs -- CHANGES.md

override_dh_makeshlibs:
	# don't call dh_makeshlibs

override_dh_compress:
	dh_compress -X.java

binary: binary-arch binary-indep

=== debian/watch ===
version=3
https://github.com/twall/jna/tags .*/(\d[\d\.]+).tar.gz debian debian/orig-tar.sh

## libjna-java 4.5.2

=== native/Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
                         -e 's/AIX.*/aix/g' \
                         -e 's/Linux.*/linux/g')
 
-JNA_JNI_VERSION=5.1.0 # auto-generated by ant
+JNA_JNI_VERSION=5.2.0 # auto-generated by ant
 CHECKSUM=74e8f8e397c43487738c5c1f1363498b # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \

=== debian/changelog ===
libjna-java (4.5.2-1build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 11:06:40 +0000

libjna-java (4.5.2-1build1) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jan 2020 08:29:34 +0000

libjna-java (4.5.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Backported the fix for the build failure with GCC 8
  * Standards-Version updated to 4.2.0
  * Removed debian/orig-tar.sh

 -- Emmanuel Bourg <ebourg@apache.org>  Mon, 13 Aug 2018 23:12:51 +0200

libjna-java (4.5.1-3) unstable; urgency=medium

  * Team upload.
  * Fixed the build failure with ant/1.10.3-2

 -- Emmanuel Bourg <ebourg@apache.org>  Mon, 02 Jul 2018 14:55:35 +0200

libjna-java (4.5.1-2) unstable; urgency=medium

  * Team upload.
  * Fixed the build failure with Java 10 (Closes: #898459)
  * Standards-Version updated to 4.1.4
  * Switch to debhelper level 11
  * Use salsa.debian.org Vcs-* URLs

 -- Emmanuel Bourg <ebourg@apache.org>  Fri, 11 May 2018 23:40:33 +0200

=== debian/control ===
--- 
+++ 
@@ -2,23 +2,25 @@
 Section: java
 Priority: optional
 Maintainer: Debian Java maintainers <pkg-java-maintainers@lists.alioth.debian.org>
-Uploaders: Jan Dittberner <jandd@debian.org>,
-           Ludovic Claude <ludovic.claude@laposte.net>,
-           Andrew Ross <ubuntu@rossfamily.co.uk>
-Build-Depends: ant,
-               ant-optional,
-               debhelper (>= 10),
-               default-jdk,
-               default-jdk-doc,
-               javahelper (>=0.32~),
-               libffi-dev,
-               libx11-dev,
-               libxt-dev,
-               maven-repo-helper (>= 1.5~),
-               pkg-config
-Standards-Version: 4.1.3
-Vcs-Git: https://anonscm.debian.org/git/pkg-java/libjna-java.git
-Vcs-Browser: https://anonscm.debian.org/cgit/pkg-java/libjna-java.git
+Uploaders:
+ Jan Dittberner <jandd@debian.org>,
+ Ludovic Claude <ludovic.claude@laposte.net>,
+ Andrew Ross <ubuntu@rossfamily.co.uk>
+Build-Depends:
+ ant,
+ ant-optional,
+ debhelper (>= 11),
+ default-jdk,
+ default-jdk-doc,
+ javahelper (>=0.32~),
+ libffi-dev,
+ libx11-dev,
+ libxt-dev,
+ maven-repo-helper (>= 1.5~),
+ pkg-config
+Standards-Version: 4.2.0
+Vcs-Git: https://salsa.debian.org/java-team/libjna-java.git
+Vcs-Browser: https://salsa.debian.org/java-team/libjna-java
 Homepage: https://github.com/twall/jna
 
 Package: libjna-java

## libjna-java 5.5.0

=== debian/changelog ===
libjna-java (5.5.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with gcc-10 due to warning that cannot be checked
    correctly. Closes: #966889

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 24 Aug 2020 11:53:52 +0100

libjna-java (5.5.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Standards-Version updated to 4.5.0

 -- Emmanuel Bourg <ebourg@apache.org>  Mon, 08 Jun 2020 00:16:29 +0200

libjna-java (4.5.2-2) unstable; urgency=medium

  * Team upload
  * Add patch to address build path in soname (Closes: #956178)
  * Specify debhelper compat 12 via debhelper-compat dependency

 -- tony mancill <tmancill@debian.org>  Fri, 10 Apr 2020 22:15:26 -0700

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  ant,
  ant-optional,
- debhelper (>= 11),
+ debhelper-compat (= 12),
  default-jdk,
  default-jdk-doc,
  javahelper (>=0.32~),
@@ -18,7 +18,7 @@
  libxt-dev,
  maven-repo-helper (>= 1.5~),
  pkg-config
-Standards-Version: 4.2.0
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/java-team/libjna-java.git
 Vcs-Browser: https://salsa.debian.org/java-team/libjna-java
 Homepage: https://github.com/twall/jna

## libjna-java 5.6.0

=== debian/changelog ===
libjna-java (5.6.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Switch to debhelper level 13
  * Standards-Version updated to 4.5.1

 -- Emmanuel Bourg <ebourg@apache.org>  Thu, 04 Feb 2021 08:02:36 +0100

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,7 @@
 Build-Depends:
  ant,
  ant-optional,
- debhelper-compat (= 12),
+ debhelper-compat (= 13),
  default-jdk,
  default-jdk-doc,
  javahelper (>=0.32~),
@@ -18,7 +18,7 @@
  libxt-dev,
  maven-repo-helper (>= 1.5~),
  pkg-config
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Git: https://salsa.debian.org/java-team/libjna-java.git
 Vcs-Browser: https://salsa.debian.org/java-team/libjna-java
 Homepage: https://github.com/twall/jna

=== debian/rules ===
--- 
+++ 
@@ -25,6 +25,7 @@
 override_dh_auto_build:
 	ln -s /usr/share/java/ant.jar lib/ant.jar
 	ant -f build.xml \
+	    -Dcompatibility=8 \
 	    -Dcflags_extra.native="" \
 	    -Ddynlink.native=true \
 	    -Dnomixedjar.native=true \

## libjna-java 5.9.0

=== native/Makefile ===
--- 
+++ 
@@ -9,9 +9,9 @@
 #
 # Supported platforms (built and tested):
 #
-#   Windows 2000/XP/2003/Vista (x86/amd64)
+#   Windows (x86/amd64/aarch64)
 #   Windows CE/Mobile (arm)
-#   Darwin/OS X (i386/x86_64/ppc)
+#   Darwin/OS X (i386/x86-64/ppc/aarch64)
 #   Linux (i386/amd64/ppc/arm)
 #   Solaris (i386/amd64/sparc/sparcv9)
 #   AIX (ppc/ppc64)
@@ -50,7 +50,7 @@
                         -e 's/AIX.*/aix/g' \
                         -e 's/Linux.*/linux/g')
 
-JNA_JNI_VERSION=5.2.0 # auto-generated by ant
+JNA_JNI_VERSION=5.1.0 # auto-generated by ant
 CHECKSUM=74e8f8e397c43487738c5c1f1363498b # auto-generated by ant
 
 JAVA_INCLUDES=-I"$(JAVA_HOME)/include" \
@@ -246,8 +246,21 @@
 ARSFX=.lib
 ifeq ($(ARCH),amd64)
 CC+= -m64
-endif
-FFI_CONFIG+= && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_SRC)/src/x86/ffitarget.h include
+FFI_TARGET=$(FFI_SRC)/src/x86/ffitarget.h
+else ifeq ($(ARCH),aarch64)
+# Force $(CC) fallback; avoid arch mismatch
+WINDRES=false
+# Disable mingw; no aarch64 support
+MINGW=
+FFI_CONFIG+=--host=aarch64-cygwin
+# Skip building assembly callback functions
+CDEFINES+= -DASMFN_OFF
+DLLCB=
+CC+= -marm64
+FFI_CONFIG+=--host=aarch64-cygwin
+endif
+FFI_TARGET?=$(FFI_SRC)/src/$(ARCH)/ffitarget.h
+FFI_CONFIG+= && rm -f include/ffitarget.h && cp $(FFI_SRC)/include/*.h $(FFI_TARGET) include
 FFI_ENV+=LD="$(LD)" CPP="$(CPP)" CXXCPP="$(CPP)"
 EXTRAOBJS+=$(DLLCB)
 
@@ -321,7 +334,7 @@
 endif
 
 # CC_OPTS only applied to objects build for jnidispatch, not for libffi
-# -Wno-unknown-warning-option 
+# -Wno-unknown-warning-option
 #                => Suppress warning for unknown warnings
 # -Werror        => Treat warnings as errors
 # -Wno-clobbered => Silence GCC warning about clobbered automatic variables.
@@ -329,6 +342,12 @@
 #                   that implements "protected" mode. In that case an exception
 #                   is raised and the value of the potentially clobbered
 #                   variables is ignored.
+# -Wno-alloca-larger-than => Silence warnings about unbounded alloca calls in
+#                   the dispatch logic. GCC tries to assert, that the size of
+#                   the allocated memory is bounded and thus a check for the
+#                   variable needs to be inplace. For the JNA case, the size
+#                   comes from the Java side, so checks are not visible on the
+#                   C side and thus can't be checked there.
 #
 # Enable this only on GCC versions, that can work with it. It is assumed, that
 # GCC version 4.X is the lower bound. That version is problematic, as it
@@ -336,7 +355,9 @@
 ifeq ($(CC),gcc)
     GCC_MAJOR_VERSION = $(shell gcc -dumpversion | cut -f 1 -d '.')
     ifneq ($(GCC_MAJOR_VERSION),4)
-	LOC_CC_OPTS=-Wno-unknown-warning-option -Werror -Wno-clobbered -Wno-unused-variable
+	ifneq ($(GCC_MAJOR_VERSION),3)
+	    LOC_CC_OPTS=-Wno-unknown-warning-option -Werror -Wno-clobbered -Wno-unused-variable -Wno-alloca-larger-than
+	endif
     endif
 else
     LOC_CC_OPTS=-Wno-unknown-warning-option -Werror -Wno-clobbered -Wno-unused-variable
@@ -371,40 +392,14 @@
 
 
 ifeq ($(OS),darwin)
-XCODE_VERSION=$(shell xcodebuild -version | grep Xcode | sed 's/^Xcode \([1-9]\).*/\1/g')
-JAVA_INCLUDES+=-I/System/Library/Frameworks/JavaVM.framework/Headers
-DEFAULT_ARCH=$(shell arch)
-ARCH=$(shell arch)
-HOST_CONFIG=--host $(ARCH)-apple-darwin
-FFI_ENV += CC="$(CC)" CFLAGS="-arch $(ARCH) $(ISYSROOT) $(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)" LD="$(LD) -arch $(ARCH)"
-ALT_ARCHS=
-ifneq ($(ARCH),i386)
-ALT_ARCHS+=i386
-endif
-ifneq ($(ARCH),x86_64)
-ALT_ARCHS+=x86_64
-endif
-ifneq ($(ARCH),ppc)
-ifeq ($(XCODE_VERSION),3)
-# Xcode 3 options
-# not supported on XCode 4+
-ALT_ARCHS+=ppc
-else
-# Xcode 4+ options
-NO_COMPACT_UNWIND=-Wl,-no_compact_unwind
-endif
-endif
-LIBSFX=.dylib
-JNISFX=.jnilib
-ifneq ($(SDKROOT),)
-SYSLIBROOT=-Wl,-syslibroot,$(SDKROOT)
-ISYSROOT=-isysroot $(SDKROOT)
-ARCHFLAGS=-arch i386 -arch x86_64
-ifeq ($(XCODE_VERSION),3)
-ARCHFLAGS+=-arch ppc
-endif
-endif
-
-PCFLAGS+=$(ISYSROOT) -x objective-c
-# JAWT no longer supported on OSX
-CDEFINES+=-DTARGET_RT_MAC_CFM=0 -DFFI_MMAP_EXEC_WRIT -DNO_JAWT
+
+DARWIN_ARCH=$(ARCH)
+ifeq ($(ARCH),aarch64)
+  DARWIN_ARCH=arm64
+else 
+ifeq ($(ARCH),x86-64)
+  DARWIN_ARCH=x86_64
+else
+ifeq ($(ARCH),x86)
+  DARWIN_ARCH=x86
+else

=== debian/changelog ===
libjna-java (5.9.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 5.9.0
  * Add build-dep on libasm-java
  * Refresh patches for new upstream version
  * Bump Standards-Version to 4.6.0

 -- tony mancill <tmancill@debian.org>  Tue, 26 Oct 2021 06:59:11 -0700

=== debian/control ===
--- 
+++ 
@@ -13,12 +13,13 @@
  default-jdk,
  default-jdk-doc,
  javahelper (>=0.32~),
+ libasm-java,
  libffi-dev,
  libx11-dev,
  libxt-dev,
  maven-repo-helper (>= 1.5~),
  pkg-config
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/java-team/libjna-java.git
 Vcs-Browser: https://salsa.debian.org/java-team/libjna-java
 Homepage: https://github.com/twall/jna

=== debian/rules ===
--- 
+++ 
@@ -24,6 +24,7 @@
 
 override_dh_auto_build:
 	ln -s /usr/share/java/ant.jar lib/ant.jar
+	ln -s /usr/share/java/asm.jar lib/asm.jar
 	ant -f build.xml \
 	    -Dcompatibility=8 \
 	    -Dcflags_extra.native="" \

## libjna-java 5.13.0

=== debian/changelog ===
libjna-java (5.13.0-2) unstable; urgency=medium

  [ tony mancill ]
  * Team upload.

  [ Alexandre Rossi ]
  * Fix JNA Hello World on armhf (Closes: #1029908)

 -- tony mancill <tmancill@debian.org>  Sat, 28 Jan 2023 15:25:15 -0800

libjna-java (5.13.0-1) unstable; urgency=medium

  * Team upload

  [ Alexandre Rossi ]
  * New upstream version 5.13.0
  * Add basic quickstart autopkgtest
  * Add debug output to autopkgtest helloworld log
  * Fix getMultiArchPath() for aarch64, armhf and ppc64el (Closes: #1028374)
  * Unfuzz patches
  * Use dpkg facilities for multiarch vars
  * Declare compliance to standards-version 4.6.2 (no change)
  * Add Rules-Require-Root
  * Force creation of lib symlinks to avoid build error
  * Update lintian overrides; source-is-missing for HTML is false positive

 -- Alexandre Rossi <niol@zincube.net>  Thu, 26 Jan 2023 22:29:46 +0100

libjna-java (5.12.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Removed the -java-doc package
  * Removed .gitattributes from the upstream tarball
  * Standards-Version updated to 4.6.1

 -- Emmanuel Bourg <ebourg@apache.org>  Mon, 05 Dec 2022 15:23:48 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
  ant-optional,
  debhelper-compat (= 13),
  default-jdk,
- default-jdk-doc,
  javahelper (>=0.32~),
  libasm-java,
  libffi-dev,
@@ -19,7 +18,8 @@
  libxt-dev,
  maven-repo-helper (>= 1.5~),
  pkg-config
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/java-team/libjna-java.git
 Vcs-Browser: https://salsa.debian.org/java-team/libjna-java
 Homepage: https://github.com/twall/jna
@@ -27,7 +27,6 @@
 Package: libjna-java
 Architecture: all
 Depends: libjna-jni, ${misc:Depends}
-Suggests: libjna-java-doc
 Description: Dynamic access of native libraries from Java without JNI
  JNA provides Java programs easy access to native shared libraries without
  writing anything but Java code - no JNI or native code is required. This
@@ -68,15 +67,3 @@
  .
  This package contains the platform library with many native functions already
  mapped as well as a set of utility interfaces that simplify native access.
-
-Package: libjna-java-doc
-Section: doc
-Architecture: all
-Depends: ${misc:Depends}
-Description: Dynamic access of native libraries from Java without JNI (documentation)
- JNA provides Java programs easy access to native shared libraries without
- writing anything but Java code - no JNI or native code is required. This
- functionality is comparable to Windows' Platform/Invoke and Python's ctypes.
- Access is dynamic at runtime without code generation.
- .
- This package contains the Javadoc API documentation.

## libjna-java 5.14.0

=== native/Makefile ===
--- 
+++ 
@@ -66,7 +66,7 @@
 FFI_SRC=$(shell pwd)/libffi
 FFI_BUILD=$(BUILD)/libffi
 FFI_LIB=$(FFI_BUILD)/.libs/libffi$(ARSFX)
-FFI_ENV=CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG)" CPPFLAGS="$(CDEFINES)"
+FFI_ENV=CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG) -DFFI_STATIC_BUILD" CPPFLAGS="$(CDEFINES) -DFFI_STATIC_BUILD"
 FFI_CONFIG=--enable-static --disable-shared --with-pic=yes
 endif
 LIBRARY=$(BUILD)/$(LIBPFX)jnidispatch$(JNISFX)
@@ -172,7 +172,7 @@
 LD=$(CC)
 RANLIB=$(PREFIX)ranlib
 STRIP=$(PREFIX)strip -x
-CDEFINES=-DNO_JAWT -DNO_WEAK_GLOBALS -DFFI_MMAP_EXEC_WRIT=1 -DFFI_MMAP_EXEC_SELINUX=0
+CDEFINES=-DFFI_STATIC_BUILD -DNO_JAWT -DNO_WEAK_GLOBALS -DFFI_MMAP_EXEC_WRIT=1 -DFFI_MMAP_EXEC_SELINUX=0
 COPT+=-fpic -ffunction-sections -funwind-tables -fno-short-enums
 JAVA_INCLUDES=
 CINCLUDES+=-I"$(NDK_PLATFORM)/arch-$(AARCH)/usr/include" # -I/usr/include
@@ -398,8 +398,3 @@
   DARWIN_ARCH=arm64
 else 
 ifeq ($(ARCH),x86-64)
-  DARWIN_ARCH=x86_64
-else
-ifeq ($(ARCH),x86)
-  DARWIN_ARCH=x86
-else

=== debian/changelog ===
libjna-java (5.14.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches

 -- Emmanuel Bourg <ebourg@apache.org>  Fri, 05 Jan 2024 17:55:29 +0100

=== debian/tests/control ===
Tests: helloworld
Depends: @, default-jdk
Restrictions: allow-stderr

## libjna-java 5.15.0

=== native/Makefile ===
--- 
+++ 
@@ -15,7 +15,9 @@
 #   Linux (i386/amd64/ppc/arm)
 #   Solaris (i386/amd64/sparc/sparcv9)
 #   AIX (ppc/ppc64)
-#   FreeBSD/OpenBSD/NetBSD (i386/amd64)
+#   DragonFly (x86-64)
+#   FreeBSD (i386/amd64/aarch64)
+#   OpenBSD/NetBSD (i386/amd64)
 #   Android (arm/armv7/aarch64/x86/x86-64/mipsel/mips64el)
 #
 # Built, but with outstanding bugs (not necessarily within JNA):
@@ -45,6 +47,7 @@
                         -e 's/NetBSD/netbsd/g' \
                         -e 's/GNU\/kFreeBSD/kfreebsd/g' \
                         -e 's/FreeBSD/freebsd/g' \
+                        -e 's/DragonFly/dragonfly/g' \
                         -e 's/OpenBSD/openbsd/g' \
                         -e 's/Darwin.*/darwin/g' \
                         -e 's/AIX.*/aix/g' \
@@ -177,7 +180,7 @@
 JAVA_INCLUDES=
 CINCLUDES+=-I"$(NDK_PLATFORM)/arch-$(AARCH)/usr/include" # -I/usr/include
 LIBS=-nostdlib -L"$(NDK_PLATFORM)/arch-$(AARCH)$(ALIBDIR)/" -lgcc -lc -ldl -lm
-LDFLAGS+=-Wl,-shared,-Bsymbolic
+LDFLAGS+=-Wl,-shared,-Bsymbolic -Wl,--build-id=sha1
 FFI_ENV=CPP="$(CPP)" CC="$(CC)" CFLAGS="$(COPT) $(CDEBUG) $(CINCLUDES)" CPPFLAGS="$(CDEFINES) $(CINCLUDES)" LIBS="$(LIBS)" RANLIB="$(RANLIB)"
 FFI_CONFIG=--enable-static --disable-shared --with-pic=yes --host=$(HOST)
 endif
@@ -288,10 +291,14 @@
 endif
 endif
 
-ifneq (,$(findstring bsd,$(OS)))
+ifneq (,$(or $(findstring bsd,$(OS)),$(findstring dragonfly,$(OS))))
 ARCH=$(shell uname -m | sed 's/i.86/i386/g')
 PCFLAGS+=-fPIC
-CINCLUDES+=-I/usr/X11R6/include
+# This is a mess: X11 headers locate in /usr/local/include on FreeBSD and
+# DragonFly, in /usr/X11R7/include on NetBSD, and in /usr/X11R6/include on
+# OpenBSD.
+CINCLUDES+=-I/usr/local/include -I/usr/X11R7/include -I/usr/X11R6/include
+CINCLUDES+=$(X11INC)  # Allow extra X11 include path if necessary.
 LDFLAGS=-o $@ -shared
 CDEFINES+=-DHAVE_PROTECTION -DFFI_MMAP_EXEC_WRIT -DUSE_DEAFULT_LIBNAME_ENCODING
 endif
@@ -366,35 +373,3 @@
 # Enable 64-bit builds if the arch demands it
 ifeq ($(CC),gcc)
 ifneq ($(OS),aix)
-ifeq ($(ARCH),amd64)
-  CC += -m64
-  LD += -m64
-endif
-ifeq ($(ARCH),ppc64)
-  CC += -m64
-  LD += -m64
-endif
-ifeq ($(ARCH),ppc64le)
-  CC += -m64
-  LD += -m64
-endif
-ifeq ($(ARCH),ppc)
-  CC += -m32
-  LD += -m32
-  HOST_CONFIG=--host=ppc-linux
-endif
-ifeq ($(ARCH),i386)
-  CC += -m32
-  LD += -m32
-endif
-endif
-endif
-
-
-ifeq ($(OS),darwin)
-
-DARWIN_ARCH=$(ARCH)
-ifeq ($(ARCH),aarch64)
-  DARWIN_ARCH=arm64
-else 
-ifeq ($(ARCH),x86-64)

=== debian/changelog ===
libjna-java (5.15.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release
    - Refreshed the patches
  * Build depend on pkgconf instead of pkg-config
  * Standards-Version updated to 4.7.0

 -- Emmanuel Bourg <ebourg@apache.org>  Wed, 23 Oct 2024 17:17:18 +0200

=== debian/control ===
--- 
+++ 
@@ -17,8 +17,8 @@
  libx11-dev,
  libxt-dev,
  maven-repo-helper (>= 1.5~),
- pkg-config
-Standards-Version: 4.6.2
+ pkgconf
+Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/java-team/libjna-java.git
 Vcs-Browser: https://salsa.debian.org/java-team/libjna-java

=== debian/watch ===
version=4
opts="repack,compression=xz" \
https://github.com/twall/jna/tags .*/(\d[\d\.]+).tar.gz
